"""
Some functions to help with setting up color segmentation.
"""

__all__ = "tile_imgs" #what's that thing to hide / show members of a module?

import os

try: import Image
except: raise ImportError("Could not find Image module, please install PIL (http://pythonware.com/)")

def tile_imgs(imgs, out=""):
    """Tiles the imgs (a directory, or a list of files) into one image ('out', which defaults to the imgs directory)"""
    if isinstance(imgs, str):
        #then it's a directory
        dir = imgs
        imgs = [os.path.join(dir,f) for f in os.listdir(dir) if f.lower().endswith("jpg") or f.lower().endswith("jpeg")]
        if imgs == []: raise ValueError("did not find any JPEG images in %s" % dir)
    elif isinstance(imgs, list):
        #then it's a list of files
        dir = os.path.dirname(imgs[0]) #we will assume they are all in this directory...

    imgs = map(Image.open, imgs)
    size = imgs[0].size #we'll again assume they are all the same (for size)
    out = Image.new(mode="RGB", size)
    raise NotImplementedError
    
        