"""
Using a Joystick with Python to control the Aibo remotely
"""

from pygame import *
from Aibo import AiboRobot

r = AiboRobot("aibo4")

LastKey = None

#to duplicate the behavior of the walk controller
#you would have to continually poll the joystick positions
#then continually send those positions


#when there is no input (or less than some threshhold)
#   send 0,0,0
#otherwise
#   send current x, current y, current z

#you would have to duplicate this behavior of continuous polling

#(or you could use keyup / keydown events)

PS2BUTTONS= {0: "TRIANGLE",
             1: "CIRCLE",
             2: "CROSS",
             3: "SQUARE",
             4: "L1",
             5: "R1",
             6: "L2",
             7: "R2",
             8: "START",
             9: "SELECT",
             10: "L3",
             11: "R3"}

def process(eventdict, eventtype):
    x,y,z = 0,0,0
    r.setTargetVelocity(x,y,z)     
    if "joy" in eventdict:
        if "value" in eventdict:
            if "axis" in eventdict:
                if eventdict["axis"] == 0:
                    z = -1*eventdict["value"]
                elif eventdict["axis"] == 1:
                    x = -1*eventdict["value"]
                elif eventdict["axis"] == 3:
                    y = -1*eventdict["value"]                
            elif "hat" in eventdict:
              print eventdict["hat"], "hat, value = ", eventdict["value"]
        elif "button" in eventdict:
            if eventtype == JOYBUTTONDOWN:
                print PS2BUTTONS[eventdict["button"]], "pressed"
    if x and abs(x) < 0.01:
        return
    if y and abs(y) < 0.01:
        return
    if z and abs(z) < 0.01:
        return
    if not (x or y or z):
        return
    print "sending", (x,y,z)
    r.setTargetVelocity(x,y,z)

init()
joystick.init()
for x in range(joystick.get_count()):
    j = joystick.Joystick(x)
    j.init()

while 1:
    for e in event.get():
        process(e.dict, e.type)